<?php
/*
Plugin Name: Embargo Press Release
Plugin URI: http://technosailor.com
Description: This plugin allows you to generate a Word-format press release of a post. It is designed for embargoed stories that you wish to release to certain individuals or agencies.
Author: Aaron Brazell
Version: 0.5
Author URI: http://technosailor.com/
*/

function embargo_pr_link()
{
	global $post;
	if ( current_user_can('edit_post', $post->ID) )
	{
		if ( is_attachment() )
			return;
		$location = get_settings('siteurl') . "/index.php?action=pressrelease&amp;post=$post->ID";
		echo $before . "<a href=\"$location\">Make Press Release</a>" . $after;
	}
}
function embargo_pr_generate()
{
	if($_GET['post'] && $_GET['action'] == 'pressrelease' )
	{
		global $wpdb;
		
		ini_set('display_errors', true);
		$postid = (int) $_GET['post'];
		$postdata = get_post( $postid );
		$authordisplayname = $wpdb->get_var( 'SELECT display_name FROM ' . $wpdb->users . ' WHERE ID = "' . $postdata->post_author . '"' );
	
		$htmlhead = '<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:w="urn:schemas-microsoft-com:office:word" xmlns="http://www.w3.org/TR/REC-html40">
		<head>
		<meta name=ProgId content=Word.Document>
		<style type="text/css">
		h1 { text-align:center; margin:0; }
		p.notice { text-align:center; margin: 0 }
		</style>
		</head>
		<body>';
		$notice = '<h1> E M B A R G O E D</h1>';
		$notice .= '<p class="notice"><em>until ' . mysql2date('F j, Y g:i a T', $postdata->post_date) . ' when it will be published at ' . get_option('siteurl'). '</em></p>';
	
		$title = '<h2>' . $postdata->post_title . '</h2>';
		
		$byline = '<p>By: ' . $authordisplayname . '</p>';
	
		$story = $postdata->post_content;
	
		$htmlfoot = '</body></html>';
		$release = $htmlhead . $notice . $title . $byline . $story . $htmlfoot;
		
		header("Content-Type: application/msword");
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("content-disposition: attachment;filename=Embargo_Press_Release_" . $postdata->post_name . ".doc");
		echo $release;
	}
}
add_action('init', 'embargo_pr_generate');
//add_action('wp_footer','embargo_pr_link',true);
?>